<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\NumberGenerator;

use Dedi\SyliusQuotePlugin\Entity\QuoteInterface;

class IdBasedQuoteNumberGenerator implements QuoteNumberGeneratorInterface
{
    private int $startNumber;

    private int $padLength;

    private string $padString;

    public function __construct(int $startNumber, int $padLength, string $padString)
    {
        $this->startNumber = $startNumber;
        $this->padLength = $padLength;
        $this->padString = $padString;
    }

    public function generate(QuoteInterface $quote): string
    {
        $number = $this->startNumber + $quote->getId();

        return str_pad((string) $number, $this->padLength, $this->padString, \STR_PAD_LEFT);
    }
}
